#ifndef SNAKE_H
#define SNAKE_H

#include <vector>
#include <iostream>
#include "Eigen/Dense"
#include "CImg.h"

using namespace Eigen;
using namespace std;
using namespace cimg_library;

class snake
{
private:
    vector <Vector2f> points;
	vector <Vector2f> normal;    
	int size;
    float gamma;
    float alpha;
    float beta;
    bool end;
    CImgList<float> extGrad;
    CImg<unsigned char> image;
    void preProcess();
public:
    snake()
    {
        size=0;
        alpha=0; 
		gamma=0;
		beta=0;
        end=false;
    }
    void assign(vector<vector<int>> ps, CImg<unsigned char> &img);
    void setParams(float _gamma, float _alpha, float _beta);
    void update();
    void display(CImg<unsigned char> &img, CImgDisplay &disp, const unsigned char *const colorPts, const unsigned char *const colorLines);
    bool stop();
};

#endif // SNAKE_H
